<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Global - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="Measure.html">Measure</a><ul class='methods'><li data-type='method' style='display: none;'><a href="Measure.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="Measure.html#add">add</a></li><li data-type='method' style='display: none;'><a href="Measure.html#asString">asString</a></li></ul></li><li><a href="webcontrols.html">webcontrols</a><ul class='members'><li data-type='member' style='display: none;'><a href="webcontrols.html#.verbose">verbose</a></li></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonOnOff">addButtonOnOff</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addButtonRange">addButtonRange</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.addConsole">addConsole</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleLog">consoleLog</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.consoleClear">consoleClear</a></li><li data-type='method' style='display: none;'><a href="webcontrols.html#.curl">curl</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#answer">answer</a></li><li><a href="global.html#gpio_digital_timing_start">gpio_digital_timing_start</a></li><li><a href="global.html#gpio_digital_timing_stop">gpio_digital_timing_stop</a></li><li><a href="global.html#gpio_digital_timing_get">gpio_digital_timing_get</a></li><li><a href="global.html#setInterval">setInterval</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Global</h1>
    

    




<section>

<header>
    
        <h2>
        
            
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

<dl class="details">
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>




            

            
        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="answer"><span class="type-signature type-signature-static">(static) </span>answer<span class="signature">(noerror, message, &hellip;parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a response to the web service.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>noerror</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>If true, uses the HTTP 200 code (no error), else the HTTP 400 code (bad request).</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>message</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The message, a string format à-la printf with more parameters if used.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">anything</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                    &lt;repeatable><br>
                
                </td>
            

            

            <td class="description last"><p>Any message parameters.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="gpio_digital_timing_start"><span class="type-signature type-signature-static">(static) </span>gpio_digital_timing_start<span class="signature">(index, mode)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Starts the digital timing observation.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>index</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The given pin index.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>mode</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The transition <code>CHANGE|FALLING|RISING</code> mode.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="gpio_digital_timing_stop"><span class="type-signature type-signature-static">(static) </span>gpio_digital_timing_stop<span class="signature">(index)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Stops the digital timing observation.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>index</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The given pin index.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="gpio_digital_timing_get"><span class="type-signature type-signature-static">(static) </span>gpio_digital_timing_get<span class="signature">(index)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets the last digital timing observation.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>index</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The given pin index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The last observation time in millisconds from the chip boot.</p>
</div>



    



        
            

    

    <h4 class="name" id="setInterval"><span class="type-signature type-signature-static">(static) </span>setInterval<span class="signature">(handler, delay, count)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Calls a handler at specified intervals (in milliseconds).</p>
<ul>
<li>Functionnalities:
<ul>
<li><em>Periodic samplig</em>: This corresponds to the <code>setInterval(handler, delay)</code> javascript mechanism.</li>
<li><em>Sampling stopping</em>: The <code>setInterval(handler, 0)</code> is equivalent to <code>cleaInterval(handler)</code> javascript mechanism.</li>
<li><em>Timeout handler call</em>: The <code>setInterval(handler, delay, 1)</code> is equivalent to <code>setTimeout(handler)</code> javascript mechanism.</li>
</ul>
</li>
<li>Requirement: In order the mechanism to be used the <code>setInterval_manage()</code> function has to be added to the processor loop, as <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/loop.cpp">examplified here</a>.</li>
<li>Precision:
<ul>
<li>The present <a href="https://gitlab.inria.fr/line/aide-group/esp32gpiocontrol/-/blob/master/src/loop.cpp"><code>loop()</code></a>
<ul>
<li>is called about every <code>1</code> millisecond (without any action to performed), while performing a <code>Serial.println</code> requires about 2 to 3 milliseconds.</li>
<li>when implementing this <code>setInterval</code> management and the webservice client handler</li>
<li>while it is delayed by the web service handle routine.</li>
</ul>
</li>
<li>The <code>millis()</code> returns the time passed since the board began running the current program.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>handler</code></td>
            

            <td class="type">
            
                
<span class="param-type">callback</span>



            
            </td>

            

            

            <td class="description last"><p>The <code>void handler()</code> routine to be called.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>delay</code></td>
            

            <td class="type">
            
                
<span class="param-type">unit</span>



            
            </td>

            

            

            <td class="description last"><p>The intervals (in milliseconds) on how often to execute the code, <code>0</code> to stop the sampling.</p>
<ul>
<li>This is performs in &quot;best effort&quot; mode, i.e., as soon as possible.</li>
<li>The 1st call is performed after the given delay.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>count</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The maximal number of calls, <code>-1</code> for endless calls.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>